#ifndef _TICKER_PROXY_H
#define _TICKER_PROXY_H

#include <string>
#include <sys/types.h>
#include <arpa/inet.h>
#include <sys/socket.h>

struct HostPort_t {
  string h;
  int p;
};

class TickerProxy {

 protected:
  int m_Sock, m_ReqSock, m_OutSock;
  unsigned int m_ReqAddrLen;
  sockaddr_in m_MyAddr;
  sockaddr_in m_ReqAddr, m_OutAddr;
  

 public:
  TickerProxy(int port);
  virtual ~TickerProxy();

  void run();

 protected:
  int GetContentLength(string s);
  int HandleConnection();
  string ReadMsg(int sock);
  string ReadMsg(int sock, int len);
  int WriteMsg(string Msg, int sock);
  int OpenConnection(const HostPort_t& dest);
  string ReadLine(int sock);
  HostPort_t GetDestination(string Msg);
};

#endif // _TICKER_PROXY_H
