/*
 * File: bse-agent.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: 15th February, 2002
 * Terms: GPL
 *
 * NICE Application Layer Multicast
 */

#ifndef _BSE_AGENT_H_
#define _BSE_AGENT_H_

#include "common-agent.h"
#include "layerinfo.h"
//#include "nicenode.h"

//PRM
#define		CLOCK_CACHE_SIZE		1024

class bseAgent : public commonAgent {

private:
  /* This is some stuff used for sending packets to an
     agent to visualize the structure of the multicast 
     group. --Ryan
  */
  int drawer_sock;
  sockaddr_in drawer_addr;

public :

  // agent id and node id are in the agent class
 
  LayerInfo * top_layer;

  // statistics
  double m_last_change;

  ~bseAgent (void) { if (top_layer != NULL) delete top_layer; };

  void start (void);
  void stop (void);
  void init (int Id, int Index, char* drawer = NULL, unsigned short dport = 0);

  int specific_rx_pkt_handler (Packet *p);  

  void handle_cluster_refresh_msg_timeout (void);
  void handle_cluster_refresh_check_timeout (void);
  /*
  Packet * reclaim_apppacket(char * recv_buffer, int len);
  int flatten_apppacket(char * payload, Packet * ap, int dst_ag);
  */

//PRM-added
  void specific_send_data_pkt();
  int send_data_pkt_to_layer( LayerInfo *l, int seqno);
//PRM

private :

    int  m_data_pkt_seq;
  int coop_agents_sofar;
  void reset_layer_info (int top_lid);
  void fill_highest_layer_info (AppPacket *p);

  void handle_join_query (AppPacket *p);
  void handle_cluster_refresh (AppPacket *p);
  int handle_data_packet (AppPacket *ap);
  void handle_data_ack_packet (AppPacket *ap);
  void handle_cluster_merge (AppPacket * ap);

  void split_top_layer_using_two_partition (void);

  void send_cluster_remove (LayerInfo *l);

  void send_top_layer_cluster_refresh (LayerAgentInfo * ignore_agent);

  void log_cluster_change_info(void);
  void display_top_layer_info (void);
  bool self_check (LayerAgentInfo * la);

//PRM-added
	double m_clock_cache[CLOCK_CACHE_SIZE];
	void handle_retransmit_request(AppPacket *ap);
	//void sleeDisplay();
//PRM


};
#endif 
  
