#ifndef _TIMEOUT_H_
#define _TIMEOUT_H_
/* Util_timeout.h -- definitions having to do with timeout structures   */
 
#include <sys/signal.h>
 
#define USEC_PER_TICK      1000000    /* one tick = 1000000 usecs */
#define CALL_UNMASK_TIMER 1
#define DONT_CALL_UNMASK_TIMER 0

/* PURIFY FIX: Added a second callback argument. */
typedef struct timeout
{
  int             to_ticks;     /* ticks left, measured from prev */
  void            (*to_fun)(int);  /* function to be called */
  int             to_arg1;      /* argument to function */
  int             to_arg2;      /* argument to function */
  struct timeout  *to_next;
  struct timeout  *to_prev;
  int             to_busy;      /* busy flag/key to id owner */
} timeout_t;
/* END PURIFY FIX */

 
typedef timeout_t *timeoutHandle_t;

typedef timeoutHandle_t o_timeoutHandle; 
 
/* Initialize timeout structures, start the clock.      */
void initTimeout(void);
 
/* Arrange for func(arg) to be called in t ticks.       */
/* PURIFY FIX: Added a second callback argument. */
o_timeoutHandle startTimer(int t, void (*func)(int a), int arg1, int arg2);
/* END PURIFY FIX */
 
/* Cancel a previously-arranged timeout.                */
int cancelTimer(o_timeoutHandle timer);

int mask_timer();
void unmask_timer();

#endif
