/*
 * File: packet.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: 15th February, 2002
 * Terms: GPL
 *
 * NICE Application Layer Multicast
 */

#ifndef _PACKET_H_
#define _PACKET_H_

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>

#define CONSTANT_LINK_DELAY 0.001 // All time info is in secs

enum PacketType {
  PACKET_NONE,
  PACKET_ROUTING,
  PACKET_APP
};

class Packet {

public :

  PacketType t;
  int id; // of the packet (to trace the packet)
  //  int src; // of the packet
  struct sockaddr_in src_agent_addr;
  int src_agent; // Equivalent to port number
  //  int dst;
  struct sockaddr_in dst_agent_addr;
  int dst_agent; // Equivalent to port number
  int size;
  double send_time;
  int process_count; // How many nodes will process this packet

  static int pkt_id_gen;

  Packet (void);
  virtual ~Packet (void);
};

#endif 


