#ifndef _TALKER_H_
#define _TALKER_H_

#include <arpa/inet.h>
#include <map>

typedef map<int, float> ping_map_t;

typedef struct {
  unsigned addr; // Network byte ordered address of host
  unsigned short port; // Port host is running the listener on
  float ping_time; // Last recorded ping time, in musecs
  int refreshed;
  struct sockaddr_in host_addr; // For convenience
  struct timeval time_of_ping; // Timestamp when ping was last recorded
} host_info_t;

struct host_info_node_t {
  host_info_t* data;
  struct host_info_node_t* next;
};

typedef struct host_info_node_t host_info_node_t;

void* ping_thread_func(void* data);
host_info_node_t *get_ping_list ();
void delete_ping_list(host_info_node_t* ping_list);
void send_pings(host_info_node_t* ping_list, int ping_time);
int accept_connection(int accept_sock);
int handle_request(int sock, char* buf, host_info_node_t*& head);
int send_response(int sock, float ping_time);
double estimate_rtt(struct sockaddr_in their_addr); 
double estimate_rtt_wrapper(struct sockaddr_in their_addr);

#endif
